/*!
 * @file new_class_id.h
 * @brief Definition of a dynamically allocating ClassID
 *
 */

#ifndef _NEW_CLASS_ID_H
#define _NEW_CLASS_ID_H

#include <string>

//! A class to dynamically allocate ClassID's and support a isA operator
class NewClassID
{
public:
  NewClassID() : _id(-1), _name("") { };
  NewClassID(int id, const std::string& name) : _id(id), _name(name) { };
  // the copy constructor is also defined.
  int id() const { return _id; };
  const std::string& name() const { return _name; };

  bool operator==(NewClassID id) const { return _id == id._id || _name == id._name; };
  bool operator==(int id) const { return _id == id; };
  bool operator==(const std::string& name) const { return _name == name; };

private:
  int            _id;
  std::string    _name;
};
#endif /* _NEW_CLASS_ID_H */
